/* 
 * Search the array [A] for the value [val] and set the flag [found] to true if
 * the value exists in A.
 */

// Try verifying with
//   gpuverify --local_size=1024 --num_groups=1             find.cl
// and
//   gpuverify --local_size=1024 --num_groups=1 --no-benign find.cl

#define tid get_local_id(0)
#define N get_local_size(0)

__kernel void find(__constant float *A, float val, uint MAX, __local bool *found) {

  *found = false;

  barrier(CLK_LOCAL_MEM_FENCE);

  if (A[tid] == val) {
    *found = true;
  }
}
