/*
 * Introducing assertions
 */

__kernel void simple(__local int *A) {

  uint tid = get_local_id(0);
  A[tid] = tid+1;

  __assert(A[tid] == tid);
  __assert(A[tid] != get_local_size(0));
  __assert(__implies(
    __write(A),
    __write_offset(A)/sizeof(int) == tid));

  // write your own assertions of the following form
  //   !e                                           logical not
  //   e1 && e2                                     logical and
  //   e1 || e2                                     logical or
  //   __implies(e1, e2)                            implication
  // give an example of an assertion that will always fail

  // what do you think about
  __assert(__implies(tid == -1, A[tid] == tid+1));
  // ?

}
