/*
 * An (obviously?) correct kernel...
 *
 * This kernel demonstrates that we may need to add *loop invariants*
 * to avoid false-positives.
 */

// Try verifying with
//   gpuverify --local_size=8 --num_groups=1 inc.cl 

__global void inc(int x) {
  __requires(0 < x);
  int i;
  i = 0;

  // A loop invariant is a property of the loop which is always true (at the loop head)
  // Can you find and express some constraint about i to allow the assertion to pass?
  // Modify the invariant in the loop head
  while(__invariant(i <= x), i < x) {
    i = i + 1;
  }
  __assert(i == x);
}
